Package tigase.xmpp.impl

# Class StartZLib

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.StartZLib

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="zlib", parent=SessionManager.class, active=true) public class StartZLib extends XMPPProcessor implements XMPPProcessorIfc
Created: Jul 29, 2009 4:03:44 PM

Author:
  Artur Hefczyc

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ID`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StartZLib()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
  `Element[]`
  `supStreamFeatures(XMPPResourceConnection session)`
  Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supDiscoFeatures, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supDiscoFeatures, supTypes`

- ## Field Details

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### StartZLib

    public StartZLib()

- ## Method Details

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `XMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `XMPPProcessor`
    Returns:
      a `String[]` value

  - ### supStreamFeatures

    public Element[] supStreamFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
    Specified by:
      `supStreamFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supStreamFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value